<?php

/* ***************************************************************************

  This is bid.php, the PHP file that handles bidding operations

  It can only be used by users that are logged in, and required the sell ID
  to be sent via HTTP GET protocol. Otherwise, it will redirect to
  search_books.php to allow the user to search for the book he / she wants
  to bid for. If the user is logged in and has sent a correct sell_id, then
  shows the current bid and asks for a new bid. When the form is submitted,
  the user's bid gets updated (if the sell is still valid, of course)

  When called directly, this file will redirect back to the index page

**************************************************************************** */

// PHP should only report big problems
error_reporting(E_ERROR);

// Page has been called, but not by our script !!
if(bath!="university")
{
  header("Location: index.php");
  die();
}

$sell_id = intval($_GET['sell_id']);

// No sell_id given ... redirect to search_books.php
if(!$sell_id)
{
  include("search_books.php");
  return;
}

//-- SQL
$query = <<<ENDOFSTRING
SELECT `BUCS_id` FROM $sellsT
WHERE `Sell_id` = $sell_id
AND `Status` = 'on sale'
AND `Date_ending` > $t
ENDOFSTRING;
//-- ENDSQL

$query = $db->query($query);
if(!DB::isError($query) && ($query->numRows())>0)
{
  $query=$query->fetchRow(DB_FETCHMODE_ORDERED);
  if($query[0] == $user_id)
  {
    // That's stupid...
    echo "This is <b>your</b> book !";
    return;
  }
}
else
{
  // Sell_id does not exist
  echo "Invalid sell ID...<br><br>Note that this may be because the seller has decided not to sell the book, or because the sell has ended.";
  return;
}

//-- SQL
$query = <<<ENDOFSTRING
SELECT `Date_ending` FROM $sellsT WHERE `Sell_id` = $sell_id AND `Status` = 'on sale'
ENDOFSTRING;
//-- ENDSQL

// Just check that the book is still sold and hasn't expired
// Note that this probably occurs when the user types in an address
$query = $db->query($query);
if(!DB::isError($query) && ($query->numRows())>0)
{
  $query=$query->fetchRow(DB_FETCHMODE_ORDERED);
  if($query[0] < $t)
  {
    // Sell_id has expired
    echo "Sorry. Bidding has ended for this book.";
    return;
  }
}
else
{
  // Sell_id does not exist or is not sold anymore
  echo "Sorry. Bidding has ended for this book.";
  return;
}

$isSelf=false;
$didBid=false;

//-- SQL
$query = <<<ENDOFSTRING
SELECT `BUCS_id` FROM $bidsT WHERE `Sell_id` = $sell_id AND `BUCS_id` = "$user_id"
ENDOFSTRING;
//-- ENDSQL

// Did the user ever bid for this book ?
$query = $db->query($query);
if(!DB::isError($query) && ($query->numRows())>0)
  $didBid=true;

//-- SQL
$query = <<<ENDOFSTRING
SELECT `Bid_price`, `BUCS_id` FROM $bidsT WHERE `Sell_id` = $sell_id ORDER BY `Bid_price` DESC LIMIT 1
ENDOFSTRING;
//-- ENDSQL

// Find the current sell price
$query = $db->query($query);
if(!DB::isError($query) && ($query->numRows())>0)
{
  // The best bidder
  $query=$query->fetchRow(DB_FETCHMODE_ORDERED);
  $price = $query[0]/10;
  $isSelf = ($query[1] == $user_id);
}
else
{
//-- SQL
$query = <<<ENDOFSTRING
SELECT `Initial_price` FROM $sellsT WHERE `Sell_id` = $sell_id
ENDOFSTRING;
//-- ENDSQL

  // Not one has bid for the book... Just take the initial price
  $query = $db->query($query);
  if(!DB::isError($query) && ($query->numRows())>0)
  {
    $query = $query->fetchRow(DB_FETCHMODE_ORDERED);
    $price = $query[0]/10;
  }
  else
  {
    // That should never happen... Normally...
    echo "Error getting price information !!";
    return;
  }
}

// What's the user's bid?
$bid = intval( read_p("form_newPrice",0)/10 );

if($bid>$price)
{
  if($didBid)
  {
  // The user has bid for this sell_id before... Update bid

//-- SQL
$query=<<<ENDOFSTRING
UPDATE $bidsT SET `Bid_price` = $bid WHERE `Sell_id` = $sell_id AND `BUCS_id` = "$user_id";
ENDOFSTRING;
//-- ENDSQL
  }
  else
  {
  // The user has never bid for this sell_id before... Create bid

//-- SQL
$query=<<<ENDOFSTRING
INSERT INTO $bidsT VALUES ($sell_id, "$user_id", $bid);
ENDOFSTRING;
//-- ENDSQL
  }
  $db->query($query);

  // Redirect to main page
  include("main.php");
  return;
}

$isSelf = false;
//-- SQL
$query = <<<ENDOFSTRING
SELECT `Bid_price`, `BUCS_id` FROM $bidsT WHERE `Sell_id` = $sell_id ORDER BY `Bid_price` DESC LIMIT 1
ENDOFSTRING;
//-- ENDSQL

// Find the best bidder (yes, again...)
$query = $db->query($query);
if(!DB::isError($query) && ($query->numRows())>0)
{
  $query = $query->fetchRow(DB_FETCHMODE_ORDERED);
  $price = $query[0]/10;
  $isSelf = ($query[1]==$user_id);
}
else
{
//-- SQL
$query = <<<ENDOFSTRING
SELECT `Initial_price` FROM $sellsT WHERE `Sell_id` = $sell_id
ENDOFSTRING;
//-- ENDSQL
  $query = $db->query($query);
  if(!DB::isError($query) && ($query->numRows())>0)
  {
    $query=$query->fetchRow(DB_FETCHMODE_ORDERED);
    $price=$query[0]/10;
  }
  else
  {
    echo "Error getting price information !!";
    return;
  }
}

  echo "
  <script>
  function checkForm()
  {
    document.form.elements[0].select();
    price=parseInt(document.form.elements[0].value);
    if(isNaN(price))
    {
      alert('That is not a number !');
      return false;
    }
    if(price<".(($price+0.1)*100).")
    {
      alert('This bid is not high enough !');
      return false;
    }
    return true;
  }
  </script>
      
  <table cellpadding='1' cellspacing='0'> 
    <tr> 
      <td align='center' valign='middle' class='Form_Cadre_title'> Book details:</td>
    <tr>
      <td class='Form_Cadre_main' width=680 align='center'>";
      include("view_book.php");
    
      if( $isSelf )
        $class = "green_text";
      else
        $class = "red_text";

  echo "
      <br>The current price for this book is <b class=$class>$price </b>, and you currently are<b class=$class>".($isSelf?"":" not")." the winner</b> of this bid.
      <br><br>
      <form name=form action=index.php?do=bid&sell_id=$sell_id$sess_id method=post onSubmit='return checkForm()'>
        If you want, you can enter a higher bid and press ENTER: 
        &nbsp;<input class=inputT style=text-align:right type=text name=form_newPrice size=5 maxlength=5> pennies
      </form>
      <br>
      </td>
    </tr>
  </table>
  <br>By bidding, you agree that your BUCS e-mail address as well as your telephone number will be given to the seller of the item in the case you win the bid...";

?>