<?php

/* ***************************************************************************

  This is create_user.php, the PHP file that handles new users

  It can be called by users that are or are not logged in, and works in
  a very simple way: it just displays a form with data we require, and
  when the form is submitted checks that no one with this BUCS ID has
  registered before. In this case it just adds the user and displays a
  page where the user can directly go to the "log in" page...

  Passwords are encoded using PHP md5() function

  When called directly, this file will redirect back to the index page

**************************************************************************** */

// PHP should only report big problems
error_reporting(E_ERROR);

// Page has been called, but not by our script !!
if(bath!="university")
{
  header("Location: index.php");
  die();
}

// Get POSTed information
$bucs = read_p("form_bucs",8);
$fname = read_p("form_fname",32);
$sname = read_p("form_sname",32);
$tel = read_p("form_tel",0);
$pwd = read_p("form_pwd",32);
$pwd2 = read_p("form_pwd2",32);

if($tel<1000000000 || $tel>9999999999)
{
  $tel=false;
}

if($bucs && $fname && $sname)
{

//-- SQL
$query = <<<ENDOFSTRING
SELECT `BUCS_id` FROM $usersT WHERE
`BUCS_id` LIKE "$bucs";
ENDOFSTRING;
//-- ENDSQL

  $result = $db->query($query);

  if (! DB::isError($result)) 
  {
    if ($result->numRows()>0) 
    {
      echo "ERROR: Someone with this BUCS ID or full name already exists!" . "<br><br>";
      $pwd=false;
      $pwd2=false;
    }
  }
  else
  {
    echo "Not successful: " . $result->getMessage() . "<br><br>";
    $pwd=false;
    $pwd2=false;
  }

  if($pwd!=$pwd2)
  {
    echo "WARNING! The 2 passwords you've entered do not match!<br><br>";
    $pwd = false;
    $pwd2 = false;
  }
  else
  {
    if(!$pwd)
    {
      $pwd=false;
      $pwd2=false;
    }
    else
    {
      // Passwords match... Encode!
      $pwd = md5($pwd);
    }
  }
}

if(!$bucs || !$fname || !$sname || !$tel || !$pwd)
{
// BUCS ID, forename, surname, telephone number or password is missing... Ask for it
?>
  <script>
  function f(number)
  {
    document.form.elements[number].select();
    return document.form.elements[number].value;
  }
  
  function checkForm()
  {
    if(f(0).length<3)
    {
      alert('Please enter your BUCS id !');
      return false;
    }
    if(f(1).length<2)
    {
      alert('Please enter your forename !');
      return false;
    }
    if(f(2).length<2)
    {
      alert('Please enter your surname !');
      return false;
    }
    tel=f(3);
    cnt=0;
    
    for(i=0;i<tel.length;i++)
    {
      cur=parseInt(tel.substring(i,i+1));
      if(cur>=0 && cur<=9)
      {
        cnt*=10;
        cnt+=cur;
      }
    }
    if(cnt<1000000000 || cnt>9999999999)
    {
      alert('That is not a phone number!');
      return false;
    }
    if(f(4).length<1)
    {
      alert('Please enter a password !');
      return false;
    }
    if(f(5)!=f(4))
    {
      alert('Please make sure you have entered the same password !');
      return false;
    }
    document.form.elements[3].value=cnt;
    return true;
  }
  </script>
  
<?php
  
  echo "
  <table cellpadding='1' cellspacing='0'> 
      <tr> 
      <td align='center' valign='middle' class='Form_Cadre_title'> Please fill in *all* fields in order to proceed</td>
      <tr>
      <td class='Form_Cadre_main' align='center'>
        <br><br>
        <form name=form action=index.php?do=create_user method=post onsubmit='return checkForm()'>
        <table width=500>
          <tr>
          <td align=right valign=middle width=250>BUCS ID: &nbsp;</td>
          <td align=left valign=top width=250>
            <input class=inputT type=text name=form_bucs size=20 maxlength=8 value=\"$bucs\">
          </td>
          </tr>
          <tr>
          <td align=right valign=middle>Forename: &nbsp;</td>
          <td align=left valign=top><input class=inputT type=text name=form_fname size=20 maxlength=32 value=\"$fname\"></td></tr>
          <tr>
          <td align=right valign=middle>Surname: &nbsp;</td>
          <td align=left valign=top>
            <input class=inputT type=text name=form_sname size=20 maxlength=32 value=\"$sname\"></td></tr>
          <tr>
          <td align=right valign=middle>Telephone: &nbsp;</td>
          <td align=left valign=top>
            <input class=inputT type=text name=form_tel size=20 maxlength=32 value=\"".($tel>0?telephone($tel):"")."\">
          </td>
          </tr>
          <tr>
          <td align=right valign=middle>Password: &nbsp;</td>
          <td align=left valign=top>
            <input class=inputT type=password name=form_pwd size=20 maxlength=32 onclick=this.select()>
          </td>
          </tr>
          <tr>
          <td align=right valign=middle>Password (again): &nbsp;</td>
          <td align=left valign=top>
            <input class=inputT type=password name=form_pwd2 size=20 maxlength=32 onclick=this.select()>
          </td>
          </tr>
        </table>
        <br>
        <input name='submit' type='image' value=Submit src='images/submit.jpg'>
        <br>
        </form>
      </td>
      </tr>
    </table>";
}
else
{
// BUCS ID, forename, surname, telephone number and password are acceptable... Insert data

//-- SQL
$query = <<<ENDOFSTRING
INSERT INTO $usersT (`BUCS_id`, `Forename`, `Surname`, `Password`, `Telephone`)
VALUES ("$bucs", "$fname", "$sname", "$pwd", $tel);
ENDOFSTRING;
//-- ENDSQL

  $result = $db->query($query);
  if (DB::isError($result)) 
    echo "Not successful: " . $result->getMessage();
  else
  {
    echo "
    <table cellpadding='1' cellspacing='0'> 
      <tr> 
        <td align='center' valign='middle' class='Form_Cadre_title'> You've been added to the database! Your details are as follows:</td>
        <tr>
        <td class='Form_Cadre_main' align='center'>
        <br><br>
      <table>
        <tr>
          <td align=right valign=top width=150><b>BUCS ID</b>: &nbsp;</td><td align=left valign=top width=350>$bucs</td>
        </tr>
        <tr>
          <td align=right valign=top><b>Forename</b>: &nbsp;</td>
        <td align=left valign=top>$fname</td>
        </tr>
        <tr>
          <td align=right valign=top><b>Surname</b>: &nbsp;</td><td align=left valign=top>$sname</td>
        </tr>
        <tr>
          <td align=right valign=top><b>Telephone</b>: &nbsp;</td>
        <td align=left valign=top>".telephone($tel)."</td>
        </tr>
        </table>
        <br><br>
      </td>
      </tr>
    </table>
    <br>
    <a href=\"index.php?do=log_in_out&user=$bucs\">Click here</a> to login with this BUCS ID and password";
  }
}
?>