<?php

/* ***************************************************************************

  This is enter_book.php, the PHP file that handles new books

  It can only be used by users that are logged in. Normally, this page is
  the page displayed when the user wants to sell a book, and is therefore
  optimized for that purpous... When called, it first asks for an ISBN
  number, and checks if this ISBN number is in the system. If this is the
  case, then the current book information is displayed and the user can:
    - confirm that this is the current book and continue selling
      (in which case he / she will be redirected to sell_book.php)
    - unfortunately see that the book information is false! In this case,
      the user can send a message to the system administrator telling
      what the problem is. Even though the administrator will see the
      person who has originally entered the book, the complaining
      user will not see it... Privacy is recpected
  If the book is not in the system, then the user is shown a form where
  the details about the book can be entered...

  When called directly, this file will redirect back to the index page

**************************************************************************** */

// PHP should only report big problems
error_reporting(E_ERROR);

// Page has been called, but not by our script !!
if(bath!="university")
{
  header("Location: index.php");
  die();
}

// Read POSTed ISBN
$isbn=read_p("form_isbn",0);

$bad_desc=read_p("form_bad_desc",10000);
if(!$isbn)
{
  // No ISBN POSTed... Is the user warning about a false book info?
  $bad_book=1;
  $isbn = intval_10d($_GET['isbn']);
}
else
{
  $bad_book=0;
}

// Do we have this ISBN in the system ?
if($isbn>0)
{

//-- SQL
$query = <<<ENDOFSTRING
SELECT `ISBN` FROM $booksT WHERE
`ISBN` = $isbn;
ENDOFSTRING;
//-- ENDSQL

  $result = $db->query($query);

  if (! DB::isError($result)) 
  {
      if ($result->numRows()>0) 
      {
        if(!$bad_desc)
        {
          if(!$bad_book)
          {
            $title = "Book with ISBN ".isbn($isbn)." found! Please verify that the information is correct:";
          }
          else
          {
            $title = "Here is the current information about the book with incorrect information:";
          }
        }
        else
        {
          $title = "Your complaint has been sent to the responsible person... Your message is as follows:";
        }

//-- SQL
$query = <<<ENDOFSTRING
SELECT `Title`, `Authors`, `Edition_nb`, `Publication_date`, `Publisher`, `Subject`, `BUCS_id` FROM $booksT WHERE `ISBN`=$isbn;
ENDOFSTRING;
//-- ENDSQL

        $result = $db->query($query);
        if(!DB::isError($result) && ($result->numRows())==1)
        {
          $result=$result->fetchRow(DB_FETCHMODE_ORDERED);
          if(!$bad_desc)
          {
            // Book found: show book info...
            // We unfortunately cannot use view_book.php, since view_book actually views a sell and not a book!
            echo "
            <table cellpadding='1' cellspacing='0'> 
            <tr> 
              <td align='center' valign='middle' class='Form_Cadre_title'> $title </td>
              <tr>
              <td class='Form_Cadre_main' width=680 align='center'>
              <br>
              <table width=500>
              <tr>
                <td align=right valign=top width=150><b>Title</b>: &nbsp;</td>
                <td align=left valign=top width=350>$result[0]</td></tr>
              <tr>
                <td align=right valign=top><b>Authors</b>: &nbsp;</td>
                <td align=left valign=top>$result[1]</td></tr>
              <tr>
                <td align=right valign=top><b>Edition number</b>: &nbsp;</td>
                <td align=left valign=top>$result[2]</td></tr>
              <tr>
                <td align=right valign=top><b>Publication date</b>: &nbsp;</td>
                <td align=left valign=top>$result[3]</td></tr>
              <tr>
                <td align=right valign=top><b>Publisher</b>: &nbsp;</td>
                <td align=left valign=top>$result[4]</td></tr>
              <tr>
                <td align=right valign=top><b>Subject</b>: &nbsp;</td>
                <td align=left valign=top>$result[5]</td>
              </tr>
              </table>
              <br>
              </td>
              </tr>
              </table>";

            if(!$bad_book)
            {
              echo "<br><a href=index.php?do=sell_book&isbn=$isbn$sess_id>Click here</a> to proceed with the book selling process.<br><br><a href=index.php?do=enter_book&isbn=$isbn$sess_id>Click here</a> if the book information is incorrect.";
            }
            else
            {
              echo "
              <br>
              <table cellpadding='1' cellspacing='0'> 
                <tr> 
                    <td align='center' valign='middle' class='Form_Cadre_title'> Please describe what's wrong with this information </td>
                  <tr>
                  <td class='Form_Cadre_main' width=680 align='center'>
                    <br>
                  <form action=index.php?do=enter_book&isbn=$isbn$sess_id method=POST>
                  <textarea name=form_bad_desc cols=80 rows=5 class=inputT></textarea>
                  <br><br>
                  <input name='submit' type='image' value=Submit src='images/submit.jpg'>
                  <br>
                  </form>
                </td>
                </tr>
              </table>";
            }
          }
          else
          {
            // Book with bad desription found... Send e-mail
            $text="Hello. This is $user_id, a user of the Bath University book bidding application.\n\n".
            "I'm sending you this message to tell you that a book in your system has incorrect information. Its current information on your database is as follows:\n\n".
            "Title: $result[0]\nAuthors: $result[1]\nEdition number: $result[2]\nPublication date: $result[3]\nPublisher: $result[4]\nSubject: $result[5]\n\n".
            "(this information has been entered by \"SOME_USER\")\n\n".
            "I would describe the problem as follows:\n\n$bad_desc\n\nThank you";

            mail(system_admin,"Incorrect book information in the book bidding system",str_replace("\"SOME_USER\"",$result[6],$text),"From: $user_id@bath.ac.uk");
            echo "
            <br>
            <table cellpadding='1' cellspacing='0'> 
              <tr> 
              <td align='center' valign='middle' class='Form_Cadre_title'> The following message has been sent to the system administrator </td>
              <tr>
              <td class='Form_Cadre_main' width=680 align='center'>
                <table width=600><tr><td class=box><div style='width:600; height:250; overflow:auto'>
                <br>".str_replace("\n","<br>",$text)."<br>&nbsp;</td></tr></table></div>
              </td>
              </tr>
            </table>
            <br>You should receive a response shortly.<br>
            <br><a href=index.php?do=main&sess_id=$sess_id>Click here</a> to go to the main page.<br>";
          }
        }
        else
        {
          // That should not happen
          echo "Not successful: " . $result->getMessage();
        }
      }
      else
      {
        // Book not found... Check if the user tried to enter it
        $name=read_p("form_title",32);
        $author=read_p("form_author",32);
        $ed_nb=read_p("form_ed_nb",0);
        $pub_date=explode(" ",read_p("form_pub_date",7));
        $pub_date[0]=intval($pub_date[0]);
        $pub_date[1]=intval($pub_date[1]);
        if($pub_date[0]<1 || $pub_date[0]>12 || $pub_date[1]<1452 || $pub_date[1]>intval(date("Y")))
        {
          $pub_date=false;
        }
        else
        {
          $months=array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
          $pub_date=$months[$pub_date[0]-1]." $pub_date[1]";
        }
        $publisher=read_p("form_publisher",32);
        $subject=read_p("form_subject",32);
        if($name && $author && $ed_nb>0 && $pub_date && $publisher && $subject)
        {
          // Yes it has! So, insert entered info and redirect

//-- SQL
$query = <<<ENDOFSTRING
INSERT INTO $booksT VALUES
($isbn,"$user_id","$name","$author","$ed_nb","$pub_date","$publisher","$subject");
ENDOFSTRING;
//-- ENDSQL

          $db->query($query);
          echo "<form method=post action=index.php?do=enter_book$sess_id name=form><input type=hidden name=form_isbn value=$isbn>If your browser does not support JavaScript redirections please <input class=inputT type=submit value='click here'> to be redirected.</form><script>document.form.submit()</script>";
        }
        else
        {
          // No, it hasn't! Ask for the book information
          // At this point, we also need to get the possible subjects list

//-- SQL
$query = <<<ENDOFSTRING
DESCRIBE $booksT `Subject`
ENDOFSTRING;
//-- ENDSQL

          $columns = $db->query($query);
          if(!DB::isError($columns) && ($columns->numRows())>0)
          {
            $columns=$columns->fetchRow(DB_FETCHMODE_ORDERED);
            $columns=explode("'",$columns[1]);
            $col_list=array();
            for($i=1;$i<sizeof($columns);$i++)
            {
              $col_list[]=$columns[$i];
              $i++;
            }
            sort($col_list);
?>
<script>
function explode(what)
{
  var temp=what.indexOf(' ')
  var result=[]
  while(temp!=-1)
  {
    result[result.length]=what.substring(0,temp)
    what=what.substring(temp+1,what.length)
    temp=what.indexOf(' ')
  }
  result[result.length]=parseInt(what)
  return result
}

function f(number)
{
  document.form.elements[number].select()
  return document.form.elements[number].value
}

function checkForm()
{
if(f(0).length<4)
{
  alert('Please enter a title !')
  return false
}

if(f(1).length<4)
{
  alert('Please enter the author name !')
  return false
}

if(isNaN(parseInt(f(2))))
{
  alert('This is not a number !')
  return false
}

date=explode(f(3))
if(date.length!=2 || date[0]<1 || date[0]>12 || date[1]<1452 || date[1]><?echo date("Y")?>)
{
  alert('This is not a date !\n\nSample date: 12 1998')
  return false
}
if(f(4).length<2)
{
  alert('Please enter the publisher !')
  return false
}
return true
}
</script>
<?php
          echo "
          <table cellpadding='1' cellspacing='0'> 
          <tr> 
            <td align='center' valign='middle' class='Form_Cadre_title'> A book with ISBN ".isbn($isbn)." does not exist in the system... Please enter details:</td>
            <tr>
            <td class='Form_Cadre_main' width=680 align='center'>
            <form name=form action=index.php?do=enter_book$sess_id method=post onsubmit='return checkForm()'>
            <table width=500>
            <tr>
              <td align=right valign=middle width=250>Title: &nbsp;</td>
              <td align=left valign=top width=250>
              <input class=inputT type=text name=form_title size=20 maxlength=32>
              </td>
            </tr>
            <tr>
              <td align=right valign=middle>Author: &nbsp;</td>
              <td align=left valign=top>
              <input class=inputT type=text name=form_author size=20 maxlength=32>
              </td>
            </tr>
            <tr>
              <td align=right valign=middle>Edition number: &nbsp;</td>
              <td align=left valign=top>
              <input class=inputT type=text name=form_ed_nb size=20 maxlength=32>
              </td>
            </tr>
            <tr>
              <td align=right valign=middle>Publication date: &nbsp;</td>
              <td align=left valign=top>
              <input class=inputT type=text name=form_pub_date size=20 maxlength=10>
              </td>
            </tr>
            <tr>
              <td align=right valign=middle>Publisher: &nbsp;</td>
              <td align=left valign=top>
              <input class=inputT type=text name=form_publisher size=20 maxlength=32>
              </td>
            </tr>
            <tr>
              <td align=right valign=middle>Subject: &nbsp;</td>
              <td align=left valign=top>
              <select class=inputT name=form_subject>";
          for($i=0;$i<sizeof($col_list);$i++)
          {
            echo "<option value='$col_list[$i]'>$col_list[$i]\n";
          }
          echo " </select>
              </td>
            </tr>
            </table>
          <input type=hidden name=form_isbn value=$isbn>
          <br>
          <input name='submit' type='image' value=Submit src='images/submit.jpg'>
          <br>
          </form>
          </td></tr></table>
          <br>Note that you are responsible for the things you enter in the system, and that your BUCS ID will be stored together with the book information.";
        }
        else
        {
          // That should not happen
          echo "Not successful: " . $columns->getMessage();
        }
      }
    }
  }
  else
  {
    // That should not happen
    echo "Not successful: " . $result->getMessage();
  }
}
else
{
  // No ISBN entered... Ask for it
?>
<script>
function f(number)
{
  document.form.elements[number].select()
  return document.form.elements[number].value
}

function checkForm()
{
  isbn=f(0)
  cnt=0
  for(i=0;i<isbn.length;i++)
  {
    cur=parseInt(isbn.substring(i,i+1))
    if(cur>=0 && cur<=9)
    {
      cnt*=10
      cnt+=cur
    }
  }
  if(cnt<1 || cnt>9999999999)
  {
    alert('That is not an ISBN number!')
    return false
  }
  document.form.elements[0].value=cnt
  return true
}
</script>
<?php
  echo "
  <table cellpadding='1' cellspacing='0'> 
   <tr> 
     <td align='center' valign='middle' class='Form_Cadre_title'>Please enter book ISBN number to proceed:</td>
   <tr>
     <td class='Form_Cadre_main' width=680 align='center'>
     <br>
     <form name=form action=index.php?do=enter_book$sess_id method=post onsubmit='return checkForm()'>
    <table width=500>
    <tr>
      <td align=right valign=middle width=250>ISBN: &nbsp;</td>
      <td align=left valign=top width=250>
      <input class=inputT type=text name=form_isbn size=20 maxlength=32>
      </td>
    </tr>
    </table>
      <br>
      <input name='submit' type='image' value=Submit src='images/submit.jpg'>
    <br>
    </form>
    </td>
  </tr>
  </table>
  ";
}

?>