<?php

/* ***************************************************************************

  This is log_in_out.php, the PHP file that handles logins & logouts

  It can be called by a user that is either logged in or logged out... If
  a logged in user called it, we log that user out, show a message for a few
  seconds and redirect back to the main page. If the user is not logged in,
  we show a form in which the user can enter his / her BUCS ID and password.
  If the BUCS ID and password submitted are incorrect, we warn the user
  and if the BUCS ID does not exist give the link for a new user creation.
  If they are both correct, then we create a session ID, make it this
  user's session ID, and send the user to the main page...

  When logging in, the user can also specify a "next place" he / she wants
  to go and this will be respected... So, if the user clicks on a bid and
  then is asked to log in, he / she will be redirected to the bid page
  (instead of the main page) after having logged in

  On campus, the PHP mail() function is not working... Therefore, we should
  not integrate an "I've lost my password, plase send a new one by e-mail"
  functionality to the system... :(

  When called directly, this file will redirect back to the index page

**************************************************************************** */

// PHP should only report big problems
error_reporting(E_ERROR);

// Page has been called, but not by our script !!
if( bath != "university" )
{
  header("Location: index.php");
  die();
}

$bucs = read_p("form_bucs",8);
$pwd = read_p("form_pwd",32);
$redirect = read_p("form_next",32);
$bid_sid = read_p("form_bid_sell_id",0);
$sell_id = intval($_GET['sell_id']);

if($pwd)
{
  $pwd = md5($pwd);
}

if($user_id && !$bucs && !$pwd)
{
// User has a user_id (is logged in) so trying to log out
 
//-- ENDSQL
$query = <<<ENDOFSTRING
UPDATE $usersT SET `Session_id`="" WHERE `BUCS_id` LIKE "$user_id";
ENDOFSTRING;
//-- ENDSQL

  $db->query($query);

  echo "<script>setTimeout(\"self.location.href='index.php?do=main'\",1234)</script><br><br>User <b>$user_id</b> has been logged out successfully.<br><br>";
}
else
{
// User has no user_id (is not logged in) or is trying to log in

  if($bucs)
  {

//-- SQL
$query = <<<ENDOFSTRING
SELECT `Password` FROM $usersT WHERE `BUCS_id` LIKE "$bucs"
ENDOFSTRING;
//-- ENDSQL

    $result = $db->query($query);
    if ( DB::isError($result) )
    {
      // This should be happening...
      echo "Not successful: ".$result->getMessage();
    }
    else
    {
      if ( $result->numRows() == 0 )
      {
          echo "Such a user does not exist! <a href=index.php?do=create_user>Click here</a> to create a new user<br><br>";
          $bucs = false;
        }
      else
      {
          $result = $result->fetchRow(DB_FETCHMODE_ORDERED);
          if(! ($result[0]==$pwd) )
        {
          if( $pwd )
          {
            echo "You've entered a wrong password!<br><br>";
          }
          $pwd=false;
        }
        else
        {
          // User has a good password! Create session
          $id = superRand();

//-- SQL
$query = <<<ENDOFSTRING
SELECT `BUCS_id` FROM $usersT WHERE `Session_id`="$id"
ENDOFSTRING;
//-- ENDSQL

          $result = $db->query($query);
          while( $result->numRows()>0 )
          {
            // Make sure we have a unique ID
            $id=superRand();

//-- SQL
$query = <<<ENDOFSTRING
SELECT `BUCS_id` FROM $usersT WHERE `Session_id`="$id"
ENDOFSTRING;
//-- ENDSQL

            $result = $db->query($query);
          }

//-- SQL
$query = <<<ENDOFSTRING
UPDATE $usersT SET `Session_id`="$id" WHERE `BUCS_id` LIKE "$bucs"
ENDOFSTRING;
//-- ENDSQL

          $db->query($query);
          echo "
          <script>self.location.href='index.php?do=".(in_array($redirect,$login_actions)?$redirect:"main").($bid_sid>0?"&sell_id=$bid_sid":"")."&sess_id=$id'</script>
          You're now logged in :)<br><br>Please <a href=index.php?do=".(in_array($redirect,$login_actions)?$redirect:"main").($bid_sid>0?"&sell_id=$bid_sid":"")."&sess_id=$id>click here</a> if your browser does not support JavaScript redirections.";
        }
      }
    }
  }
  else
  {
  // User has not entered a BUCS ID... Just check if there's some data
  // sent to the script about the user that's trying to log in
    $user = substr(str_replace(array("<","\\'","\\\"","\\\\","\""),array("&lt;","'","\"","\\","'"),$_GET['user']),0,32);
    if( strlen( $user ) > 2 )
    {
      $bucs=$user;
      $pwd=false;
    }
  }

  if( !$bucs || !$pwd )
  {
    echo "
    <table cellpadding='1' cellspacing='0'> 
        <tr> 
        <td align='center' valign='middle' class='Form_Cadre_title'> Please enter your BUCS ID and password to proceed</td>
      <tr>
        <td class='Form_Cadre_main' align='center'>
        <br><br>
        <form action=index.php?do=log_in_out method=post>
        <table width=500>
          <tr>
            <td align=right valign=middle width=250>BUCS ID : &nbsp;</td>
          <td align=left valign=top width=250>
            <input class=inputT type=text name=form_bucs size=20 maxlength=8 value=\"$bucs\"></td>
          </tr>
          <tr>
           <td align=right valign=middle>Password : &nbsp;</td>
         <td align=left valign=top>
           <input class=inputT type=password name=form_pwd size=20 maxlength=32></td>
          </tr>
        </table>
        ".
        ($do=="log_in_out"?"":"<input type=hidden name=form_next value='$do'>")."
        ".
        ($do=="bid"?"<input type=hidden name=form_bid_sell_id value=$sell_id>":"")."
        <br>
        <input name='submit' type='image' value=Submit src='images/submit.jpg'>
        <br>
        </form>
      </td>
      </tr>
    </table>";
  }
}

?>