<?php

/* ***************************************************************************

  This is view_book.php, the PHP file that shows the information about
  a book that is sold with a particular sale ID.

  It normally cannot be directly accessed by any way (using just its
  address or by typing index.php?do=view_book), and is only included
  by the bid.php and sell_book.php files... Before calling it, we place
  a variable $sell_id with the desired sale ID in it... The script will
  then show in a table the book, sell and price information for this
  sell ID.

  When called directly, this file will redirect back to the index page

**************************************************************************** */

// PHP should only report big problems
error_reporting(E_ERROR);

// Page has been called, but not by our script !!
if(bath!="university")
{
  header("Location: index.php");
  die();
}

//-- SQL
$query = <<<ENDOFSTRING
SELECT * FROM
$booksT JOIN $sellsT ON $booksT.`ISBN` = $sellsT.`ISBN`
WHERE `Sell_id` = $sell_id;
ENDOFSTRING;
//-- ENDSQL

//-- SQL
$query2 = <<<ENDOFSTRING
SELECT `Bid_price` FROM
$bidsT
WHERE `Sell_id` = $sell_id
ORDER BY `Bid_price` DESC
LIMIT 1;
ENDOFSTRING;
//-- ENDSQL

$result=$db->query($query);
$result2=$db->query($query2);

// Print the information about the book pointed by sell_id
if(!DB::isError($result) && ($result->numRows())>0 && !DB::isError($result2))
{
  $result=$result->fetchRow(DB_FETCHMODE_ASSOC);
  if(($result2->numRows())>0)
  {
    $result2=$result2->fetchRow(DB_FETCHMODE_ORDERED);
    $price=$result2[0]/10;
  }
  else
  {
    $price=$result["Initial_price"]/10;
  }
  echo "
    <table>
      <tr>
        <td align=right valign=top width=150><b>ISBN</b>: &nbsp;</td><td align=left valign=top width=350>".isbn($result['ISBN'])."</td>
      </tr>
      <tr>
        <td align=right valign=top width=150><b>Book name</b>: &nbsp;</td><td align=left valign=top width=350>".$result['Title']."</td>
      </tr>
      <tr>
        <td align=right valign=top width=150><b>Written by</b>: &nbsp;</td><td align=left valign=top width=350>".$result['Authors']."</td>
      </tr>
      <tr>
        <td align=right valign=top width=150><b>Condition</b>: &nbsp;</td><td align=left valign=top width=350>".$result['Condition']."</td>
      </tr>
      <tr>
        <td align=right valign=top width=150><b>Bidding started</b>: &nbsp;</td><td align=left valign=top width=350>".date("H:i @ d.m.Y",$result['Date_started'])."</td>
      </tr>
      <tr>
        <td align=right valign=top width=150><b>Bidding ends</b>: &nbsp;</td><td align=left valign=top width=350>".date("H:i @ d.m.Y",$result['Date_ending'])."</td>
      </tr>
      <tr>
        <td align=right valign=top width=150><b>Current status</b>: &nbsp;</td><td align=left valign=top width=350>".$result['Status']."</td>
      </tr>
      <tr>
        <td align=right valign=top width=150><b>Current price</b>: &nbsp;</td><td align=left valign=top width=350>$price </td>
      </tr>
    </table>";
}
else
{
  // That should not happen
  echo "Error retreiving data";
}

?>